

MAKE=make
CP=cp -f
RM=rm -f
MKDIR=mkdir -p
ECHO=echo

TOP=.
OUT_D=$(TOP)/out_emx
TMP_D=$(TOP)/tmp_emx

O_SSL=$(OUT_D)/ssl10_s.lib
O_CRYPTO=$(OUT_D)/crypt10_s.lib
L_CRYPTO=$(OUT_D)/crypto.a
L_SSL=$(OUT_D)/ssl.a
L_CRYPTO_LIB=$(OUT_D)/crypto.lib
L_SSL_LIB=$(OUT_D)/ssl.lib
SO_SSL=$(OUT_D)/emssl10.dll
SO_CRYPTO=$(OUT_D)/emcrpt10.dll

CRYPTO_TEMPLATE_DEF=$(TOP)/os2/ossl10_crypto_os2emx.def
CRYPTO_DEF=$(TMP_D)/cryptemx.def
SSL_TEMPLATE_DEF=$(TOP)/os2/ossl10_ssl_os2emx.def
SSL_DEF=$(TMP_D)/sslemx.def

MAKEFILE_OS2=$(TOP)/os2/OS2-EMX-gcc.mak
MAKEFILE_APPS=Makefile.apps-os2emx
APPS_SED=$(TOP)/os2/apps_os2emx.sed

LDFLAGS=-s -Zmt -Zstack 8192
SHARED_LDFLAGS=-s -Zdll -Zomf -Zmt

EX_LIBS=-lsocket -lz -Zcrtdll

all: $(SO_CRYPTO) $(SO_SSL) $(L_CRYPTO) $(L_SSL) app tools

install_sw:
	$(MAKE) -C $(TOP) "LDFLAGS=$(LDFLAGS)" "EX_LIBS=$(EX_LIBS)" "EXE_EXT=.exe" install_sw

tools: $(TOP)/crypto.a $(TOP)/ssl.a
	$(MAKE) -C $(TOP) "LDFLAGS=$(LDFLAGS)" "EX_LIBS=$(EX_LIBS)" "EXE_EXT=.exe" build_tools

app: $(OUT_D)/openssl.exe

openssl.pc: $(TOP)/libcrypto.a $(TOP)/libssl.a $(OUT_D)/openssl.exe
	$(MAKE) -C $(TOP) "EXE_EXT=.exe" libcrypto.pc libssl.pc openssl.pc

mkapps: $(TMP_D)/$(MAKEFILE_APPS)

$(L_SSL): $(SSL_DEF)
	emximp -o $@ $<

$(L_CRYPTO): $(CRYPTO_DEF)
	emximp -o $@ $<

$(L_SSL_LIB): $(SSL_DEF)
	emximp -o $@ $<

$(L_CRYPTO_LIB): $(CRYPTO_DEF)
	emximp -o $@ $<

$(SO_CRYPTO): $(O_CRYPTO) $(CRYPTO_DEF)
	gcc $(SHARED_LDFLAGS) -o $@ $(O_CRYPTO) $(CRYPTO_DEF) $(EX_LIBS)

$(SO_SSL): $(O_SSL) $(L_CRYPTO_LIB) $(SSL_DEF)
	gcc $(SHARED_LDFLAGS) -o $@ $(O_SSL) $(L_CRYPTO_LIB) $(SSL_DEF) $(EX_LIBS)

$(SSL_DEF): $(SSL_TEMPLATE_DEF) $(O_SSL)
	-$(MKDIR) $(TMP_D)
	$(CP) $(SSL_TEMPLATE_DEF) $@
	$(ECHO) "EXPORTS" >> $@
	emxexp $(O_SSL) >> $@

$(CRYPTO_DEF): $(CRYPTO_TEMPLATE_DEF) $(O_CRYPTO)
	-$(MKDIR) $(TMP_D)
	$(CP) $(CRYPTO_TEMPLATE_DEF) $@
	$(ECHO) "EXPORTS" >> $@
	emxexp $(O_CRYPTO) >> $@

$(O_SSL): $(TOP)/libssl.a
	-$(MKDIR) $(OUT_D)
	emxomf -p128 -o $@ $<

$(O_CRYPTO): $(TOP)/libcrypto.a
	-$(MKDIR) $(OUT_D)
	emxomf -p128 -o $@ $<

$(TMP_D)/$(MAKEFILE_APPS): $(TOP)/apps/Makefile $(MAKEFILE_OS2)
	$(ECHO) "OUT ?= out_emx" > $@
	$(ECHO) "LDFLAGS ?= $(LDFLAGS)" >> $@
	sed -f $(APPS_SED) < $< >> $@

$(TOP)/crypto.a: $(TOP)/libcrypto.a
	$(CP) $< $@

$(TOP)/ssl.a: $(TOP)/libssl.a
	$(CP) $< $@

$(TOP)/libcrypto.a: $(TOP)/Makefile
	$(MAKE) -C $(TOP) build_crypto build_engines libcrypto.pc "LDFLAGS=$(LDFLAGS)" "EX_LIBS=$(EX_LIBS)" "EXE_EXT=.exe"

$(TOP)/libssl.a: $(TOP)/Makefile
	$(MAKE) -C $(TOP) build_ssl openssl.pc libssl.pc "LDFLAGS=$(LDFLAGS)" "EX_LIBS=$(EX_LIBS)" "EXE_EXT=.exe"

$(OUT_D)/openssl.exe: $(TOP)/Makefile $(TMP_D)/$(MAKEFILE_APPS) $(L_SSL) $(L_SSL_LIB) $(L_CRYPTO) $(L_CRYPTO_LIB) $(TOP)/crypto.a $(TOP)/ssl.a
	$(MAKE) -C $(TOP) build_apps "LDFLAGS=$(LDFLAGS)" "EX_LIBS=$(EX_LIBS)" "EXE_EXT=.exe"
	@$(MKDIR) $(OUT_D)/bin_static
	$(CP) apps/openssl.exe $(OUT_D)/bin_static
	$(MAKE) -C apps -f ../tmp_emx/$(MAKEFILE_APPS) "OUT=../out_emx" "LDFLAGS=$(LDFLAGS)" "EX_LIBS=$(EX_LIBS)" "EXE_EXT=.exe" exe


